(function ($) {
    "use strict";

    //  Added modal animation effects
    $(window).on('show.bs.modal', function () {
        $('.modal-content').addClass('animated fast zoomInUp');
    });

    // Change chart default font color
    Chart.defaults.global.defaultFontFamily = "Montserrat-Light";
    Chart.defaults.global.defaultFontSize = 11;

    //  Search
    $(document).on('click', 'body', function(event) {
        $('#top_search .dropdown-menu').removeClass('display-block');
    });

    $(document).on('click', 'body', function(event) {
        $('.navbar-nav .dropdown-menu').removeClass('in');
    });

    $(document).on('click', '.dropdown-menu', function(event) {
        event.stopPropagation();
    });

    $(document).on('click', '#top_search', function(event) {
        event.stopPropagation();
    });

    //  Added mode Dark
    $(document).on('click', '.mode', function(event) {
        event.preventDefault();
        $("body").stop().toggleClass('dark-only');
        if($('body').hasClass('dark-only')){
			localStorage.setItem('theme', 'dark-only');
		}else {
			localStorage.setItem('theme', '');
		}
    });

    //  Added Fullscreen
    $(document).on('click', '.full_screen', function(event) {
        event.preventDefault();
 
        $(this).find('.feather_full').toggleClass('open');

        if(IsFullScreenCurrently())
            GoOutFullscreen();
        else
            GoInFullscreen($("html").get(0));
    });

    $(document).on('click', '.hide-menu', function(event) {
        event.preventDefault();
        if($('body').hasClass('hide-sidebar')){
			localStorage.setItem('sidebar', 'hide-sidebar');
		}else {
			localStorage.setItem('sidebar', '');
		}
    });

    

    //  Added Items
    $("#header nav > .navbar-nav .full_screen").appendTo('.navbar-nav.navbar-right');

    $("#header nav > .navbar-nav .mode").appendTo('.navbar-nav.navbar-right,ul.mobile-icon-menu');
    
    $("#header .tw-flex > .navbar-nav .full_screen").prependTo('.navbar-nav.navbar-right');

    $("#header .tw-flex > .navbar-nav .mode").prependTo('.navbar-nav.navbar-right,ul.mobile-icon-menu');

    $("body:not(.mobile) #header .navbar-nav>li#top_search_button").prependTo('.navbar-nav.navbar-right');

    $("#header .tw-flex .navbar-nav .header-user-profile").appendTo('.navbar-nav.navbar-right');
    
    $(".hide-menu i").attr('data-feather','align-center');

    $("#header .hide-menu").wrap( "<div class='header-left'></div>" );

    $("#header .navbar-nav>li.header-notifications").addClass('icon');

    $("#menu>.nav #logo").appendTo('.header-left');

    $("#header > #logo").appendTo('.header-left');

    $( "a.dark.logo" ).appendTo( "#logo,.small-logo .text-primary" );

    // $("<li class='dashboard_user'></li>").prependTo("#menu>.nav" );

    
    // var titleAttr = $('.header-user-profile').attr('title');
    // var titleLogout = $('body #header .navbar-nav>li.header-user-profile .dropdown-menu .header-logout>a').text();

    // $( "li.dashboard_user" ).html(titleAttr);

    // $("<div class='dashboard_user-icon' data-toggle='tooltip' data-title='' data-placement='right' onclick='logout(); return false;'><i data-feather='log-out'></i></div>").appendTo("li.dashboard_user");
    
    // $( "li.dashboard_user .dashboard_user-icon" ).attr('data-title',titleLogout);

    // $("#header #top_search + .navbar-nav").prependTo('li.dashboard_user');

    $('#side-menu li').each(function () {
        // Get the title from the menu text
        var title = $(this).find('.menu-text').text().trim();
        
        // Add data-title and data-placement attributes
        $(this).attr('data-toggle', 'tooltip');
        $(this).attr('data-original-title', title);
        $(this).attr('data-placement', 'bottom');
    });

    $(document).off("mousemove");

    //  feather
    feather.replace();

})(jQuery);

$( document ).ready(function() {
    //  Loading
    setTimeout(function() { 
        $('body').removeClass('loading');  
    }, 300);

    //  localStorage Dark
    var theme = localStorage.getItem('theme');  
    if(theme !== ''){      
        $('body').addClass(theme);
    }

    var sidebar = localStorage.getItem('sidebar');  
    if(sidebar !== ''){      
        $('body').addClass(sidebar);
    }
});


// Fullscreen finctions
function GoInFullscreen(element) {
    if(element.requestFullscreen)
        element.requestFullscreen();
    else if(element.mozRequestFullScreen)
        element.mozRequestFullScreen();
    else if(element.webkitRequestFullscreen)
        element.webkitRequestFullscreen();
    else if(element.msRequestFullscreen)
        element.msRequestFullscreen();
}

function GoOutFullscreen() {
    if(document.exitFullscreen)
        document.exitFullscreen();
    else if(document.mozCancelFullScreen)
        document.mozCancelFullScreen();
    else if(document.webkitExitFullscreen)
        document.webkitExitFullscreen();
    else if(document.msExitFullscreen)
        document.msExitFullscreen();
}

function IsFullScreenCurrently() {
    var full_screen_element = document.fullscreenElement || document.webkitFullscreenElement || document.mozFullScreenElement || document.msFullscreenElement || null;

    if(full_screen_element === null)
        return false;
    else
        return true;
}