<?php

defined('BASEPATH') or exit('No direct script access allowed');

class Perfex_luxe_theme extends AdminController
{
    public function __construct()
    {
        parent::__construct();

        if (!is_admin()) {
            access_denied('Perfex Luxe Theme');
        }
    }

    public function style()
    {
        $data['title'] = _l('perfex_luxe_theme_style');
        
        $this->load->view('perfex_luxe_theme_style', $data);
    }

    public function reset()
    {
        update_option('perfex_luxe_theme_style', '[]');
        update_option('perfex_luxe_theme_style_dark', '');
        update_option('perfex_luxe_theme_default_theme', '');
        update_option('perfex_luxe_theme_custom_css', '');
        update_option('perfex_luxe_theme_show_dark', '');
        update_option('perfex_luxe_theme_show_fullscreen', '');
        redirect(admin_url('perfex_luxe_theme/style'));
    }

    public function save()
    {
        hooks()->do_action('before_save_perfex_luxe_theme_style');

        $style = $this->input->post('data');
        update_option('perfex_luxe_theme_style', $style);

        $style_dark = $this->input->post('style_dark') ? 1 : 0;
        update_option('perfex_luxe_theme_style_dark', $style_dark);

        $default_theme = $this->input->post('default_theme');
        update_option('perfex_luxe_theme_default_theme', $default_theme);

        $custom_css = $this->input->post('custom_css');
        $custom_css = trim($custom_css);
        $custom_css = nl2br($custom_css);
        update_option('perfex_luxe_theme_custom_css', $custom_css);

        $show_dark = $this->input->post('show_dark') ? 1 : 0;
        update_option('perfex_luxe_theme_show_dark', $show_dark);

        $show_fullscreen = $this->input->post('show_fullscreen') ? 1 : 0;
        update_option('perfex_luxe_theme_show_fullscreen', $show_fullscreen);

    }
}
