<?php
defined('BASEPATH') or exit('No direct script access allowed');
init_head();
?>
<div id="wrapper">
   <div class="content">
      <div class="row">
         <div class="col-md-3 picker">
            <ul class="nav navbar-pills navbar-pills-flat nav-tabs nav-stacked" id="luxe_theme_styling_areas">
               <li role="presentation" class="active">
                  <a href="#tab_customize_theme_styling" aria-controls="tab_customize_theme_styling" role="tab" data-toggle="tab">
                     <?php echo _l('perfex_luxe_theme_style_customize_theme'); ?>
                  </a>
               </li>
               <li role="presentation">
                  <a href="#tab_customize_theme_custom_css" aria-controls="tab_customize_theme_custom_css" role="tab" data-toggle="tab">
                     <?php echo _l('perfex_luxe_theme_style_custom_css'); ?>
                  </a>
               </li>
               <li role="presentation">
                  <a href="#tab_customize_theme_setting" aria-controls="tab_customize_theme_setting" role="tab" data-toggle="tab">
                     <?php echo _l('perfex_luxe_theme_style_theme_settings'); ?>
                  </a>
               </li>
            </ul>
         </div>
         <div class="col-md-9">
            <div class="panel_s">
               <div class="panel-body pickers">
                  <div class="tab-content">
                     <div role="tabpanel" class="tab-pane ptop10 active" id="tab_customize_theme_styling">
                        <div class="row">
                           <div class="col-md-10">
                              <div class="form-group">
                                 <?php
                                    $default_theme = get_option('perfex_luxe_theme_default_theme');
                                 ?>
                                 <label for="luxe_default_theme" class="bold mbot10 control-label clearfix"><?php echo _l('luxe_theme_default_theme'); ?></label>
                                 <div class="radio radio-primary radio-inline wrap-split">
                                    <input type="radio" id="y_opt_0_luxe_default_theme" name="perfex_luxe_theme_default_theme" value="0" <?php if(!$default_theme){echo 'checked';} ?>>
                                    <label for="y_opt_0_luxe_default_theme">
                                       <span class="split-layout default">
                                          <span class="split-layout-top"></span>
                                          <span class="split-layout-left"></span>
                                          <span class="split-layout-right"></span>
                                       </span>
                                       <span class="radio-text"><?php echo _l('luxe_theme_default_theme_default'); ?></span>
                                    </label>
                                 </div>
                                 <div class="radio radio-primary radio-inline wrap-split">
                                    <input type="radio" id="y_opt_1_luxe_default_theme" name="perfex_luxe_theme_default_theme" value="1" <?php if($default_theme == '1'){echo 'checked';} ?>>
                                    <label for="y_opt_1_luxe_default_theme">
                                       <span class="split-layout header-only">
                                          <span class="split-layout-top"></span>
                                          <span class="split-layout-left"></span>
                                          <span class="split-layout-right"></span>
                                       </span>
                                       <span class="radio-text">Header</span>
                                    </label>
                                 </div>
                                 <div class="radio radio-primary radio-inline wrap-split">
                                    <input type="radio" id="y_opt_2_luxe_default_theme" name="perfex_luxe_theme_default_theme" value="2" <?php if($default_theme == '2'){echo 'checked';} ?>>
                                    <label for="y_opt_2_luxe_default_theme">
                                       <span class="split-layout sidebar-only">
                                          <span class="split-layout-top"></span>
                                          <span class="split-layout-left"></span>
                                          <span class="split-layout-right"></span>
                                       </span>
                                       <span class="radio-text"><?php echo _l('luxe_theme_default_theme_sidebar'); ?></span>
                                    </label>
                                 </div>
                                 <div class="radio radio-primary radio-inline wrap-split">
                                    <input type="radio" id="y_opt_3_luxe_default_theme" name="perfex_luxe_theme_default_theme" value="3" <?php if($default_theme == '3'){echo 'checked';} ?>>
                                    <label for="y_opt_3_luxe_default_theme">
                                       <span class="split-layout">
                                          <span class="split-layout-top"></span>
                                          <span class="split-layout-left"></span>
                                          <span class="split-layout-right"></span>
                                       </span>
                                       <span class="radio-text"><?php echo _l('luxe_theme_default_theme_siderbar_header'); ?></span>
                                    </label>
                                 </div>
                              </div>
                           </div>

                           <div class="col-md-2">
                              <div class="form-group">
                                 <label class="bold mbot10 inline-block"><?php echo _l('luxe_theme_style_dark');  ?></label>
                                 <div class="onoffswitch">
                                    <input type="checkbox" data-switch-url="" name="style_dark" class="onoffswitch-checkbox" id="luxe_theme_style_dark" data-id="" <?php if(get_option('perfex_luxe_theme_style_dark')){echo 'checked';} ?>>
                                    <label class="onoffswitch-label" for="luxe_theme_style_dark"></label>
                                 </div>
                              </div>
                           </div>
                              
                           <?php
                           foreach (luxe_theme_get_styling_areas('customize_theme') as $area) { ?>
                              <div class="col-md-12">
                                 <hr />
                                 <div class="form-group">
                                    <label class="bold mbot10 inline-block"><?php echo $area['name']; ?></label>
                                    <?php luxe_theme_render_styling_picker(
                                       $area['id'],
                                       luxe_theme_get_custom_style_values('customize_theme', $area['id']),
                                       '',
                                       $area['css_var'],
                                       ''
                                    );
                                    ?>
                                    <hr />
                                 </div>
                              </div>
                           <?php } ?>
                        </div>
                     </div>

                     <div role="tabpanel" class="tab-pane ptop10" id="tab_customize_theme_custom_css">
                        <div class="form-group">
                           <label class="bold" for="perfex_luxe_theme_custom_css_area">
                              <i class="fa fa-question-circle" data-toggle="tooltip" data-title="<?php echo _l('theme_style_ca_info'); ?>"></i>
                              <?php echo _l('perfex_luxe_theme_style_custom_css'); ?>
                           </label>
                           <textarea name="perfex_luxe_theme_custom_css_area"
                           id="perfex_luxe_theme_custom_css_area"
                           rows="15"
                           class="form-control"><?php echo clear_textarea_breaks(get_option('perfex_luxe_theme_custom_css')); ?></textarea>
                        </div>
                     </div>
                     <div role="tabpanel" class="tab-pane ptop10" id="tab_customize_theme_setting">
                        <div class="row">
                           <div class="col-md-6">
                              <div class="form-group">
                                 <label class="bold mbot10 inline-block"><?php echo _l('luxe_theme_show_dark');  ?></label>
                                 
                                 <div class="onoffswitch">
                                    <input type="checkbox" data-switch-url="" name="show_dark" class="onoffswitch-checkbox" id="luxe_theme_show_dark" data-id="" <?php if(get_option('perfex_luxe_theme_show_dark')){echo 'checked';} ?>>
                                    <label class="onoffswitch-label" for="luxe_theme_show_dark"></label>
                                 </div>
                              </div>
                           </div>
                           <div class="col-md-6">
                              <div class="form-group">
                                 <label class="bold mbot10 inline-block"><?php echo _l('luxe_theme_show_fullscreen');  ?></label>
                                 
                                 <div class="onoffswitch">
                                    <input type="checkbox" data-switch-url="" name="show_fullscreen" class="onoffswitch-checkbox" id="luxe_theme_show_fullscreen" data-id="" <?php if(get_option('perfex_luxe_theme_show_fullscreen')){echo 'checked';} ?>>
                                    <label class="onoffswitch-label" for="luxe_theme_show_fullscreen"></label>
                                 </div>
                              </div>
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
      </div>
      <div class="btn-bottom-pusher"></div>
      <div class="btn-bottom-toolbar text-right">
         <a href="#" onclick="save_luxe_theme_style(); return false;" class="btn btn-info"><?php echo _l('save'); ?></a>
         <a href="<?php echo admin_url('perfex_luxe_theme/reset'); ?>" class="btn btn-default"><?php echo _l('reset'); ?></a>
      </div>
   </div>
</div>
<?php init_tail(); ?>
<script>
   var pickers = $('.colorpicker-component');
   $(function() {
      $.each(pickers, function() {

         $(this).colorpicker({
            format: "hex"
         });

         $(this).colorpicker().on('changeColor', function(e) {
            var color = e.color.toHex();
            var color_rgb = e.color.toRGB();
            color_rgb = color_rgb.r + ',' + color_rgb.g + ',' + color_rgb.b;
            var _class = 'style_' + $(this).find('input').data('id');
            var val = $(this).find('input').val();
            if (val == '') {
               $('.' + _class).remove();
               return false;
            }
            var color_css = '--' + $(this).data('css');
            var append_data = '';
            append_data += ':root {' + color_css + ':' + color + ';' + color_css + '-rgb:' + color_rgb + ';}';

            if ($('head').find('.' + _class).length > 0) {
               $('head').find('.' + _class).html(append_data);
            } else {
               $("<style />", {
                  class: _class,
                  type: 'text/css',
                  html: append_data
               }).appendTo("head");
            }
         });
      });

      $(document).on('click', '#luxe_theme_style_dark', function(event) {
         if ($(this).is(":checked")){
            $("body").stop().addClass('dark-only');
         } else {
            $("body").stop().removeClass('dark-only');
         }
      });

      $('input[type=radio][name=perfex_luxe_theme_default_theme]').change(function() {
         $("body").stop().removeClass('sidebar_color');
         $("body").stop().removeClass('header_color');
         switch (this.value){
            case '1':
               $("body").stop().addClass('header_color');
               break;
            case '2':
               $("body").stop().addClass('sidebar_color');
               break;
            case '3':
               $("body").stop().addClass('sidebar_color');
               $("body").stop().addClass('header_color');
               break;
            default:
               $("body").stop().removeClass('sidebar_color');
               $("body").stop().removeClass('header_color');
            }
      });
   });

   function save_luxe_theme_style() {
      var data = [];

      $.each(pickers, function() {
         var color = $(this).find('input').val();
         if (color != '') {
            var _data = {};
            _data.id = $(this).find('input').data('id');
            _data.color = color;
            data.push(_data);
         }
      });
      $.post(admin_url + 'perfex_luxe_theme/save', {
         data: JSON.stringify(data),
         style_dark: $('#luxe_theme_style_dark').is(":checked")? 1 : 0,
         default_theme: $('input[type=radio][name=perfex_luxe_theme_default_theme]:checked').val(),
         custom_css: $('#perfex_luxe_theme_custom_css_area').val(),
         show_dark: $('#luxe_theme_show_dark').is(":checked")? 1 : 0,
         show_fullscreen: $('#luxe_theme_show_fullscreen').is(":checked")? 1 : 0,
      }).done(function() {
         var tab = $('#luxe_theme_styling_areas').find('li.active > a:eq(0)').attr('href');
         tab = tab.substring(1, tab.length)
         window.location = admin_url + 'perfex_luxe_theme/style?tab=' + tab;
      });
   }
</script>

<!-- Google tag (gtag.js) -->
<script async src="https://www.googletagmanager.com/gtag/js?id=G-84YFCGD32F"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'G-84YFCGD32F');
</script>
</body>

</html>